/* Runtime.c -- env.core.Runtime  ENI ڵ
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eRE.

eRE is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eRE is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#include "apr.h"
#include "apr_portable.h"
#include "apr_strings.h"
#include "apr_thread_proc.h"
#include "apr_signal.h"
#define APR_WANT_STDIO
#define APR_WANT_STRFUNC
#include "apr_want.h"

#if APR_HAVE_UNISTD_H
#include <unistd.h>
#endif
#if APR_HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#define CORE_PRIVATE

#include "ap_config.h"
#include "httpd.h"
#include "scoreboard.h"

#include "vm.h"

/*  ׽Ʈ Դϴ.  */
eboolean_t
env_core_Runtime__load (path, do_search)
     estring_t path;
     eboolean_t do_search;
{
  char cpath[MAXPATHLEN];

  eobject_to_char_buffer (path, cpath, MAXPATHLEN);
  if (load_nativelib (get_eserver_pool (), cpath) < 0)
    return -1;

  return 0;
}
