/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_CALL_H
#define ENV_CALL_H

#define EFIELD_INFO_ENV(NODE)		((NODE)->e)
#define EFIELD_INFO_FIELD(NODE)		((NODE)->field)
#define EFIELD_INFO_NAME(NODE)		((NODE)->name)
#define EFIELD_INFO_TYPE(NODE)		((NODE)->type)

struct efield_info 
{
  env_t e;
  efield_t *field;
  strconst_t *name;
  strconst_t *type;
};

#define EMETHOD_INFO_ENV(NODE)		((NODE)->e)
#define EMETHOD_INFO_METHOD(NODE)	((NODE)->method)
#define EMETHOD_INFO_NAME(NODE)		((NODE)->name)
#define EMETHOD_INFO_TYPE(NODE)		((NODE)->type)

/* EVM   Ư environment  method  ȣϰ  , ׿  
    Ǵ ü̴.  */
struct emethod_info 
{
  env_t e;
  emethod_t *method;
  strconst_t *name;
  strconst_t *type;
};

extern int call_method_a (emethod_t *, void *, void *, evalue_t *, evalue_t *);
extern eobjectref_t * call_constructor (const char *, env_t, const char *, ...);

#endif
