/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef VM_CONFIG_H
#define VM_CONFIG_H

/* Splay Tree  thread-safe ϰ Ϸ Ʒ  1  ϿѴ.  ׷
   ʴٸ 0  Ѵ.  */
#define VM_THREAD_SAFE_SPLAY_TREE	1

#ifdef ENV_DEBUG
#define E_ASSERT(_expr)	((_expr) ? ((void) 0) : assert (# _expr))
#else
#define E_ASSERT(_expr)	((void) 0)
#endif

#endif
