#!/usr/bin/env python2.4
# -*- coding: euc-kr -*-

import httplib, urllib
import mimetypes
import sys, getopt

def get_content_type (filename):
	return mimetypes.guess_type (filename)[0] or 'application/octet-stream'

def encode_multipart_formdata (fields, files):
	BOUNDARY = '---------------------------41184676334'
	CRLF = '\r\n'
	L = []
	for z in range (0, len (fields), 2):
		key = fields[z];
		value = fields[z+1];
		L.append ('--' + BOUNDARY)
		L.append ('Content-Disposition: form-data; name="%s"' % key)
		L.append ('')
		L.append (value)
	for z in range (0, len (files), 2):
		L.append ('--' + BOUNDARY)
		L.append ('Content-Disposition: form-data; name="%s"; filename="%s"' % (key, filename))
		L.append ('Content-Type: %s' % get_content_type(filename))
		L.append ('')
		L.append (file(filename,'rb').read ())
	L.append ('--' + BOUNDARY + '--')
	L.append ('')
	body = CRLF.join (L)
	content_type = 'multipart/form-data; boundary=%s' % BOUNDARY
	return content_type, body

def usage ():
	print ":"
	print "  $ %s [-t <number>] [-c <METHOD>] <OPTIONS>" % sys.argv[0]
	print ""
	print "-t  ɼ:  û Ѵ."
	print "  1: ELOAD          /env/core/string.eclass"
	print "  2: ELOAD          /env/testsuite/t1.eclass"
	print "  3: EINVOKESTATIC  /env/testsuite/t1.eclass?__KEY=owFRRGIQG7V+ldX+/R1AMye+MlA=&__NAME=main&__TYPE=()V"
	print "  4: ELOAD          /env/testsuite/t7.eclass"
	print "  5: EINVOKESTATIC  /env/testsuite/t7.eclass?__KEY=tfgx+1Vv2mho9kw2UIW16MDQRz4=&__NAME=main&__TYPE=()V"
	print "  6: ELOAD          /env/testsuite/t8.eclass"
	print "  7: EINVOKESTATIC  /env/testsuite/t8.eclass?__KEY=tfgx+1Vv2mho9kw2UIW16MDQRz4=&__NAME=main&__TYPE=()V"
	print "  8: ELOAD          /env/testsuite/t9.eclass"
	print ""
	print "<METHOD>  ɼ:"
	print "  ELOAD\t\t\tRE  ϴ environment  load   Ѵ."
	print "  EINVOKEVIRTUAL\t̹ εǾ ִ eclass  Ư method  ȣѴ."
	print ""
	print "<OPTIONS>  ɼ:"
	print "  ELOAD\tArgument [1]: Load  environment  ο ڸ ش."
	print "      \t  ⼭ ζ  ϴ  θ ϸ"
	print "      \t  ڴ ? ڿ ٴ  argument  Ѵ."
	print ""
	print "      \t    ) %s ELOAD \"/env/core/string.eclass?__KEY=n7J2znmJv5pCocpie/1eATzhXBY=\"" % sys.argv[0]
	print ""
	print "  EINVOKEVIRTUAL\tArgument [1]: ȣ eclass  key, method, type  ڷ ش."
	print ""
	print "      \t    ) %s EINVOKEVIRTUAL \"/env/core/string.eclass?__KEY=n7J2znmJv5pCocpie/1eATzhXBY=&__NAME=main&__TYPE=()V\"" % sys.argv[0]

if len (sys.argv) < 2:
	usage ();
	sys.exit (0);

opt_testmode = -1;
opt_command = "";

try:
	opts, args = getopt.getopt (sys.argv[1:], "t:c:");
except getopt.error, reason:
	print reason;
	sys.exit (-1);

for opt in opts:
	(lopt, ropt) = opt;
	if lopt == "-t":
		opt_testmode = ropt;
	elif lopt == "-c":
		opt_command = ropt;

METHOD	= opt_command;
ARGS = []
FILES = []
TARGET = "";

if METHOD == "ELOAD":
	TARGET = sys.argv[2]
elif (opt_testmode > 0):
	print "* Testing  ";
	if opt_testmode == "1":
		METHOD = "ELOAD";
		TARGET = "/env/core/string.eclass";
	elif opt_testmode == "2":
		METHOD = "ELOAD";
		TARGET = "/env/testsuite/t1.eclass";
	elif opt_testmode == "3":
		METHOD = "EINVOKESTATIC";
		TARGET = "/env/testsuite/t1.eclass?__KEY=owFRRGIQG7V%2BldX%2B/R1AMye%2BMlA=&__NAME=main&__TYPE=()V";
	elif opt_testmode == "4":
		METHOD = "ELOAD";
		TARGET = "/env/testsuite/t7.eclass";
	elif opt_testmode == "5":
		METHOD = "EINVOKESTATIC";
		TARGET = "/env/testsuite/t7.eclass?__KEY=tfgx%2B1Vv2mho9kw2UIW16MDQRz4=&__NAME=main&__TYPE=()V";
	elif opt_testmode == "6":
		METHOD = "ELOAD";
		TARGET = "/env/testsuite/t8.eclass";
	elif opt_testmode == "7":
		METHOD = "EINVOKESTATIC";
		TARGET = "/env/testsuite/t8.eclass?__KEY=RpTb5Zfl1cJdblvqp4FO0TZofbg=&__NAME=main&__TYPE=()V";
	elif opt_testmode == "8":
		METHOD = "ELOAD";
		TARGET = "/env/testsuite/t9.eclass";
	elif opt_testmode == "9":
		METHOD = "EINVOKESTATIC";
		TARGET = "/env/testsuite/t9.eclass?__KEY=U%2BlWzxIWrpKXC5rrYr3pmrFOvtg=&__NAME=main&__TYPE=()V";
else:
	usage ();
	sys.exit (0);

print "METHOD : %s" % METHOD
print "TARGET : %s" % TARGET
print "ARGS   :", ARGS
print "FILES  :", FILES

# ڷ   ̸
HOST	= '192.168.29.128:8080'

if METHOD == "ELOAD":
	headers = { "Message-ID":       "a93ee47ee2f259bd64d9c1a968491844-20041031100309.GA0",
	            "Accept":           "*/*" }
	body = ""
else:
	content_type, body = encode_multipart_formdata (ARGS, FILES)
	headers = { "Message-ID":	"a93ee47ee2f259bd64d9c1a968491844-20041031100309.GA0",
		    "Accept": 		"*/*",
		    "Content-Type": 	content_type, 
		    "Content-Length":	len (body) }

conn = httplib.HTTPConnection (HOST)

conn.request (METHOD, TARGET, body, headers = headers)
response = conn.getresponse ()
val = response.status
msg = response.read ()

print "status = ", val
print msg

conn.close ()
