#ifndef ERRORS_H
#define ERRORS_H

extern void warning PARAMS ((const char *, ...));
extern void error   PARAMS ((const char *, ...));
extern void fatal   PARAMS ((const char *, ...)) ATTRIBUTE_NORETURN;
extern void internal_error   PARAMS ((const char *, ...)) ATTRIBUTE_NORETURN;
extern const char *trim_filename   PARAMS ((const char *));
extern void fancy_abort PARAMS ((const char *, int, const char *))
    ATTRIBUTE_NORETURN;

extern int have_error;
extern const char *progname;
    
#endif
